

import * as Path from "path";
import * as Process from "process";
import * as Log$WonderLog from "../../../../../node_modules/wonder-log/lib/es6_global/src/Log.js";
import * as Tester$WonderBenchmark from "../../../../../node_modules/wonder-benchmark/lib/es6_global/src/Tester.js";
import * as PerformanceTestData$Wonderjs from "./data/PerformanceTestData.js";
import * as GenerateDebug$WonderBenchmark from "../../../../../node_modules/wonder-benchmark/lib/es6_global/src/GenerateDebug.js";
import * as GenerateReport$WonderBenchmark from "../../../../../node_modules/wonder-benchmark/lib/es6_global/src/GenerateReport.js";
import * as GenerateBenchmark$WonderBenchmark from "../../../../../node_modules/wonder-benchmark/lib/es6_global/src/GenerateBenchmark.js";

function generateBenchmark() {
  GenerateBenchmark$WonderBenchmark.removeFiles(Path.join(Process.cwd(), "./test/e2e/performance/benchmark"));
  var copiedTargetDirForBaseScript = Path.join(Process.cwd(), "./dist/base");
  GenerateDebug$WonderBenchmark.removeFiles(Path.join(Process.cwd(), "./test/e2e/performance/report"), copiedTargetDirForBaseScript);
  Log$WonderLog.log("copy base script to " + (String(copiedTargetDirForBaseScript) + "..."));
  Tester$WonderBenchmark.copyBaseScript(PerformanceTestData$Wonderjs.performanceTestData);
  return Tester$WonderBenchmark.generateBenchmark(PerformanceTestData$Wonderjs.performanceTestData);
}

function generateReport(reportFilePath, failList) {
  GenerateReport$WonderBenchmark.removeFile(Path.join(Process.cwd(), "./test/e2e/performance/report/report.html"));
  GenerateDebug$WonderBenchmark.removeFiles(Path.join(Process.cwd(), "./test/e2e/performance/report"), undefined);
  return Tester$WonderBenchmark.generateReport(reportFilePath, failList, PerformanceTestData$Wonderjs.performanceTestData);
}

function generateAllCasesReport(reportFilePath) {
  GenerateReport$WonderBenchmark.removeFile(Path.join(Process.cwd(), "./test/e2e/performance/report/report.html"));
  GenerateDebug$WonderBenchmark.removeFiles(Path.join(Process.cwd(), "./test/e2e/performance/report"), undefined);
  return Tester$WonderBenchmark.generateAllCasesReport(reportFilePath, PerformanceTestData$Wonderjs.performanceTestData);
}

function runTest(browserArr) {
  return Tester$WonderBenchmark.runTest(browserArr, PerformanceTestData$Wonderjs.performanceTestData);
}

export {
  generateBenchmark ,
  generateReport ,
  generateAllCasesReport ,
  runTest ,
  
}
/* path Not a pure module */
